#define		CTRL_LINEEDIT		TEXT("LINEEDIT")
#define		CTRL_TIMEEDIT		TEXT("TIMEEDIT")
#define		CTRL_BIGLIST		TEXT("BIGLIST")
#define		CTRL_LABEL			TEXT("KLABEL")
#define		CTRL_SOFTKEY		TEXT("SOFTKEY")
#define		CTRL_CONFIRM		TEXT("CONFIRM")

#define		RBM_GETSJIS			(WM_USER+0x100)
#define		RBM_SETSJIS			(WM_USER+0x101)
#define		RBM_GETMODIFY		(WM_USER+0x102)
#define		RBM_SETMODIFY		(WM_USER+0x103)
#define		RBN_ENTER			0x0100
#define		RBN_ESC				0x0101
#define		RBN_TAB				0x0102
#define		RBN_STAB			0x0103
#define		RBN_CHANGE			0x0104
#define		RBN_KEYDOWN			0x0105
#define		RBN_KILLFOCUS		0x0106

#define		TEM_GETTIMEVAL		(WM_USER+0x100)
#define		TEM_SETTIMEVAL		(WM_USER+0x101)
#define		TEM_GETMODIFY		(WM_USER+0x102)
#define		TEM_SETMODIFY		(WM_USER+0x103)
#define		TEN_ENTER			0x0100
#define		TEN_ESC				0x0101
#define		TEN_TAB				0x0102
#define		TEN_STAB			0x0103
#define		TEN_CHANGE			0x0104
#define		TEN_KEYDOWN			0x0105
#define		TEN_KILLFOCUS		0x0106

#define		BLM_SETPROC			(WM_USER+0x100)
#define		BLM_SETSPACEPROC	(WM_USER+0x101)
#define		BLM_GETCURSEL		(WM_USER+0x102)
#define		BLM_SETCURSEL		(WM_USER+0x103)
#define		BLN_ENTER			0x0100
#define		BLN_ESC				0x0101
#define		BLN_TAB				0x0102
#define		BLN_STAB			0x0103
#define		BLN_CHANGE			0x0104

#define		LAM_SETINVERT		(WM_USER+0x100)
#define		LAM_SETCROSS		(WM_USER+0x101)
#define		LAN_CLICK			0x100

#define		CONFIRM_SETINPUT	(WM_USER+0x100)
#define		CONFIRM_SETFIXED	(WM_USER+0x101)
#define		CONFIRM_SETCOLSEL	(WM_USER+0x102)
#define		CONFIRMN_CHAR		0x100
#define		CONFIRMN_CODE		0x101

#define		SOFTKEY_SETBITMAP	(WM_USER+0x100)
#define		SOFTKEY_SETLIST		(WM_USER+0x101)
#define		SOFTKEY_GETCUR		(WM_USER+0x102)
#define		SOFTKEY_SETCUR		(WM_USER+0x103)
#define		SOFTKEY_GETCURCAND	(WM_USER+0x104)
#define		SOFTKEY_SETCOLSEL	(WM_USER+0x105)
#define		SOFTKEYN_CHAR		0x100

#define		IDM_FEPOK			(41260)
#define		IDM_FEPACTIVE		(41261)
#define		IDM_FEPKEY			(41262)

extern "C" {
	BOOL	LineEditRegisterClass( HINSTANCE hInst ) ;
	BOOL	BigListRegisterClass( HINSTANCE hInst ) ;
	BOOL	LabelRegisterClass( HINSTANCE hInst ) ;
	BOOL	TimeEditRegisterClass( HINSTANCE hInst ) ;
	BOOL	SoftKeyRegisterClass( HINSTANCE hInst ) ;
	BOOL	ConfirmRegisterClass( HINSTANCE hInst ) ;
} ;

#define sjis2unicode(sjis, unicode, len)	MultiByteToWideChar(CP_ACP, 0, (char*)sjis, -1, unicode, len)
#define unicode2sjis(unicode, sjis, len)	WideCharToMultiByte(CP_ACP, 0, unicode, -1, (char*)sjis, len, NULL, NULL)
