#include	<windows.h>
#include	<windowsx.h>
#include	<commctrl.h>
#include	<commdlg.h>
#include	<tchar.h>
#include	"basewin.h"
#include	"resource.h"
#include	"dialog.h"

#define sjis2unicode(sjis, unicode, len)	MultiByteToWideChar(CP_ACP, 0, (char*)sjis, -1, unicode, len)
#define unicode2sjis(unicode, sjis, len)	WideCharToMultiByte(CP_ACP, 0, unicode, -1, (char*)sjis, len, NULL, NULL)

//TCHAR s_Prev[128];
TCHAR s_Word[128];
TCHAR s_Yomi[128];

//---------------------------------------------------------------
static int OnInitdialog (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	HWND hItem;

//	hItem = GetDlgItem (hDlg, IDC_EPREV);
//	SetWindowText (hItem, s_Prev);

	hItem = GetDlgItem (hDlg, IDC_EWORD);
	SetWindowText (hItem, s_Word);

	hItem = GetDlgItem (hDlg, IDC_EYOMI);
	SetWindowText (hItem, s_Yomi);

	return TRUE;
}

//---------------------------------------------------------------
static int OnCmdOk (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	HWND hItem;

//	hItem = GetDlgItem (hDlg, IDC_EPREV);
//	GetWindowText (hItem, s_Prev, sizeof(s_Prev)/sizeof(TCHAR));

	hItem = GetDlgItem (hDlg, IDC_EWORD);
	GetWindowText (hItem, s_Word, sizeof(s_Word)/sizeof(TCHAR));

	hItem = GetDlgItem (hDlg, IDC_EYOMI);
	GetWindowText (hItem, s_Yomi, sizeof(s_Yomi)/sizeof(TCHAR));

	if (s_Word[0] == 0 || s_Word[0] == TEXT(' ')) {
		return FALSE;
	}
	if (s_Yomi[0] == 0 || s_Yomi[0] == TEXT(' ')) {
		return FALSE;
	}

	return TRUE;
}

//---------------------------------------------------------------
LRESULT CALLBACK AdddicDlgProc( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam )
{
	switch (message)
	{
	case WM_INITDIALOG:
		return OnInitdialog (hDlg, message, wParam, lParam);

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDOK:
			if (!OnCmdOk (hDlg, message, wParam, lParam)) {
				MessageBeep( MB_ICONHAND ) ;
				return TRUE;
			}
		case IDCANCEL:
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;

		}
		break;
	}
    return FALSE;
}

//---------------------------------------------------------------
int DlgAdddic (HINSTANCE hInst, HWND hWnd, LPCSTR p, LPCSTR c, LPCSTR y)
{
//	sjis2unicode( (LPBYTE) p, s_Prev, 127 ) ;
	sjis2unicode( (LPBYTE) c, s_Word, 127 ) ;
	sjis2unicode( (LPBYTE) y, s_Yomi, 127 ) ;

	int rc = DialogBox (hInst, (LPCTSTR)IDD_DLG_ADDDIC, hWnd, (DLGPROC)AdddicDlgProc);
	if (rc == IDOK) {
	//	unicode2sjis( s_Prev, (LPBYTE) p, 127 ) ;
		unicode2sjis( s_Word, (LPBYTE) c, 127 ) ;
		unicode2sjis( s_Yomi, (LPBYTE) y, 127 ) ;
	}

	return rc;
}
//---------------------------------------------------------------
//---------------------------------------------------------------
