#include	<windows.h>
#include	<windowsx.h>
#include	<commctrl.h>
#include	<commdlg.h>
#include	<tchar.h>
#include	"basewin.h"
#include	"resource.h"
#include	"dialog.h"

extern HWND g_hWndMain;
extern "C" {
	extern	DWORD	g_dwHotFunc;	//@\L[蓖(Hotkey Code)
	extern	BOOL	g_nmHotFunc;	//@\L[蓖(Func. No.)
};

char* t_stHotNum[] = {
	"Ȃ",
	"Po^",
	"َ",
	"SЂ炪",
	"SJ^Ji",
	"p",
	"[}ϊ",
	"pؑ",
	"召ϊ",
	"دް",
	"",
};

LPWSTR hotnum_unicode[] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, };

#define IDM_NOTIFY_CLIP  50009

int t_idHotNum[] = {
	0,
	IDM_ADDDICTDLG,
	IDM_TAB,
	IDM_ZENHIRA,
	IDM_ZENKATA,
	IDM_HAN,
	IDM_ROMA,
	IDM_JPNENG,
	IDM_BIGSMALL,
	IDM_NOTIFY_CLIP,
	0,
};

extern BOOL	(*g_pRegisterHotKey)( HWND hWnd, int id, UINT fsModifiers, UINT vk );
extern BOOL	(*g_pUnregisterHotKey)( HWND hWnd, int id );

LRESULT OptionNotifyProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

int VkGetCode (TCHAR* szKey);
TCHAR* VkGetName (WORD wKey);

//---------------------------------------------------------------
static int OnInitdialog (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	HWND hItem;
	//TCHAR buf[80];
	int i;

	WORD wKey = LOWORD(g_dwHotFunc);
	hItem = GetDlgItem (hDlg, IDC_EVKCODE);
	SetWindowText (hItem, VkGetName(wKey));

	int wAlt = HIWORD(g_dwHotFunc);
	if (wAlt & MOD_ALT) {
		hItem = GetDlgItem (hDlg, IDC_CALT);
		SendMessage (hItem, BM_SETCHECK, 1, 0);
	}
	if (wAlt & MOD_WIN) {
		hItem = GetDlgItem (hDlg, IDC_CWIN);
		SendMessage (hItem, BM_SETCHECK, 1, 0);
	}
	if (wAlt & MOD_CONTROL) {
		hItem = GetDlgItem (hDlg, IDC_CCTRL);
		SendMessage (hItem, BM_SETCHECK, 1, 0);
	}
	if (wAlt & MOD_SHIFT) {
		hItem = GetDlgItem (hDlg, IDC_CSHIFT);
		SendMessage (hItem, BM_SETCHECK, 1, 0);
	}

	for (i = 0; *t_stHotNum[i] != 0; i++) {
	  if (!hotnum_unicode[i]) {
	    hotnum_unicode[i] = new WCHAR[256];
	  }
		MultiByteToWideChar(CP_ACP, 0, t_stHotNum[i], -1, hotnum_unicode[i], 256);
		SendDlgItemMessage (hDlg, IDC_CBFUNC, CB_ADDSTRING, (WPARAM) 0, (LPARAM) hotnum_unicode[i] ) ;
	  //		SendDlgItemMessage (hDlg, IDC_CBFUNC, CB_ADDSTRING, (WPARAM) 0, (LPARAM) t_stHotNum[i] ) ;
	}
	SendDlgItemMessage (hDlg, IDC_CBFUNC, CB_SETCURSEL, (WPARAM) g_nmHotFunc, 0 ) ;

	return TRUE;
}

//---------------------------------------------------------------
static int OnCmdOk (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int rc;
	HWND hItem;
	TCHAR buf[80];

	hItem = GetDlgItem (hDlg, IDC_EVKCODE);
	GetWindowText (hItem, buf, sizeof(buf)/sizeof(TCHAR));

	int wKey;
	//swscanf (buf, TEXT("%x"), &wKey);
	wKey = VkGetCode (buf);

	int wAlt = 0;
	hItem = GetDlgItem (hDlg, IDC_CALT);
	rc = SendMessage (hItem, BM_GETCHECK, 0, 0);
	if (rc) wAlt |= MOD_ALT;
	hItem = GetDlgItem (hDlg, IDC_CWIN);
	rc = SendMessage (hItem, BM_GETCHECK, 0, 0);
	if (rc) wAlt |= MOD_WIN;
	hItem = GetDlgItem (hDlg, IDC_CCTRL);
	rc = SendMessage (hItem, BM_GETCHECK, 0, 0);
	if (rc) wAlt |= MOD_CONTROL;
	hItem = GetDlgItem (hDlg, IDC_CSHIFT);
	rc = SendMessage (hItem, BM_GETCHECK, 0, 0);
	if (rc) wAlt |= MOD_SHIFT;

	g_nmHotFunc = SendDlgItemMessage( hDlg, IDC_CBFUNC, CB_GETCURSEL, 0, 0 ) ;
	if (g_nmHotFunc < 0) g_nmHotFunc = 0;

	DWORD dwHotKey = MAKELONG(wKey, wAlt);
	if (dwHotKey != g_dwHotFunc) {
#ifdef	_WIN32_WCE
		if ( g_pUnregisterHotKey ) {
			/* zbgL[ */
			if (g_dwHotFunc) {
				(*g_pUnregisterHotKey)( g_hWndMain, 0x0001 ) ;
			}
			g_dwHotFunc = 0;
		}
#endif
		g_dwHotFunc = dwHotKey;
		/* zbgL[o^ */
		if ( g_pRegisterHotKey && g_dwHotFunc && g_nmHotFunc ) {
#ifdef	_WIN32_WCE
			(*g_pRegisterHotKey)( g_hWndMain, 0x0001, HIWORD(g_dwHotFunc), LOWORD(g_dwHotFunc) ) ;
#endif
		} else {
			g_dwHotFunc = 0;
			g_nmHotFunc = 0;
		}
	}
	
	return TRUE;
}

//---------------------------------------------------------------
BOOL CALLBACK HotfuncDlgProc( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam )
{
	switch (message)
	{
	case WM_INITDIALOG:
		return OnInitdialog (hDlg, message, wParam, lParam);

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDOK:
			OnCmdOk (hDlg, message, wParam, lParam);
		case IDCANCEL:
		//	EndDialog(hDlg, LOWORD(wParam));
			return TRUE;

		}
		break;
	case WM_NOTIFY:
		return OptionNotifyProc(hDlg, message, wParam, lParam);
	}
    return FALSE;
}

//---------------------------------------------------------------
//---------------------------------------------------------------
