#include	<windows.h>
#include	<windowsx.h>
#include	<commctrl.h>
#include	<commdlg.h>
#include	<tchar.h>
#include	"basewin.h"
#include	"resource.h"
#include	"dialog.h"

#if _WIN32_WCE > 299
#define _POCKETPC	1
#endif

#define IDC_BTN_DICT 51009

extern	DWORD	g_dwAppVersion ;
extern	DWORD	g_dwDllVersion ;
extern  DWORD   g_dwQtaVersion ;

extern "C" {
	extern	TCHAR	g_szDictBase[ MAX_PATH ] ;
	extern	DWORD	g_dwPreWait ;
	extern	DWORD	g_dwPostWait ;
	extern	DWORD	g_dwSoftKey ;		/* 0:NONE, 1:HIRA, 2:ROMA */
	extern	BOOL	g_fLeftPos ;		/* ʒutO */
	extern	DWORD	g_fJis ;
	extern	BOOL	g_fSaveDic ;		/* wKtO */
	extern	BOOL	g_fPredict ;		/* \\tO */
	extern	HWND	g_hWndDialog ;
	extern	BOOL	g_fUpDnMode ;	//㉺L[̓
	extern	BOOL	g_inputkana;	//ȓ
} ;

static	BOOL	DictOpenDlg( HINSTANCE hInst, HWND hWnd, LPTSTR buf, DWORD size ) ;

BOOL CALLBACK SetupDlgProc( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam );
BOOL CALLBACK SetupDlgProc2( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam );
BOOL CALLBACK HotkeyDlgProc( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam );
BOOL CALLBACK FontDlgProc( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam );
BOOL CALLBACK AboutDlgProc( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam );
BOOL CALLBACK HotfuncDlgProc( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam );
BOOL CALLBACK ClipchkDlgProc( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam );
void FontSetup (HWND hWnd);


static int CALLBACK PropSheetCallback (HWND hwndDlg, UINT message, LPARAM lParam)
{
	switch(message) {
	case WM_CREATE:
		g_hWndDialog = hwndDlg;
		break;
#ifdef _POCKETPC
	case PSCB_GETVERSION:
		return COMCTL32_VERSION;
#endif
	}
	return 0;
}

LRESULT OptionNotifyProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	PSHNOTIFY *pshn = (PSHNOTIFY FAR *) lParam;
	NMHDR *lpnmhdr = (NMHDR FAR *)&pshn->hdr;

	switch(lpnmhdr->code)
	{
	case PSN_APPLY:				//OK
		SendMessage(hDlg, WM_COMMAND, IDOK, 0);
		break;

	case PSN_QUERYCANCEL:		//LZ
		break;
	}
	return PSNRET_NOERROR;
}

BOOL Setup_DialogBox ( HINSTANCE hInst, HWND hWnd )
{
	PROPSHEETPAGE psp;
	PROPSHEETHEADER psh;
	HPROPSHEETPAGE hpsp[12];
	int iPage = 0;

	psp.dwSize    = sizeof(PROPSHEETPAGE);
	psp.dwFlags   = PSP_DEFAULT;
	psp.hInstance = hInst;

	psp.pszTemplate = MAKEINTRESOURCE(IDD_DLG_SETUP);
	psp.pfnDlgProc  = SetupDlgProc;
	hpsp[iPage] = CreatePropertySheetPage(&psp);
	iPage++;

	psp.pszTemplate = MAKEINTRESOURCE(IDD_DLG_SETUP2);
	psp.pfnDlgProc  = SetupDlgProc2;
	hpsp[iPage] = CreatePropertySheetPage(&psp);
	iPage++;

	psp.pszTemplate = MAKEINTRESOURCE(IDD_DLG_HKEY);
	psp.pfnDlgProc  = HotkeyDlgProc;
	hpsp[iPage] = CreatePropertySheetPage(&psp);
	iPage++;

	psp.pszTemplate = MAKEINTRESOURCE(IDD_DLG_KEYFUNC);
	psp.pfnDlgProc  = HotfuncDlgProc;
	hpsp[iPage] = CreatePropertySheetPage(&psp);
	iPage++;

	psp.pszTemplate = MAKEINTRESOURCE(IDD_DLG_FONT);
	psp.pfnDlgProc  = FontDlgProc;
	hpsp[iPage] = CreatePropertySheetPage(&psp);
	iPage++;

	psp.pszTemplate = MAKEINTRESOURCE(IDD_OPT_CLIP);
	psp.pfnDlgProc  = ClipchkDlgProc;
	hpsp[iPage] = CreatePropertySheetPage(&psp);
	iPage++;

	psp.pszTemplate = MAKEINTRESOURCE(IDD_DLG_ABOUT);
	psp.pfnDlgProc  = AboutDlgProc;
	hpsp[iPage] = CreatePropertySheetPage(&psp);
	iPage++;


	memset (&psh, 0, sizeof(PROPSHEETHEADER));
	psh.dwSize      = sizeof(PROPSHEETHEADER);
#ifdef _POCKETPC
	psh.dwFlags     = PSH_MAXIMIZE | PSH_NOAPPLYNOW | PSH_USECALLBACK;
#else
	psh.dwFlags     = PSH_NOAPPLYNOW | PSH_USECALLBACK;
#endif
	psh.hInstance   = hInst;
	psh.hwndParent  = NULL;
	psh.pszCaption  = TEXT("Setup");
	psh.nPages      = iPage;
	psh.phpage      = hpsp;
	psh.nStartPage  = 0;
	psh.pfnCallback = PropSheetCallback;

	g_hWndDialog = NULL;
	int rc = PropertySheet(&psh);

	if (rc == IDOK) {
		FontSetup (hWnd);
	}
	
	return rc;
}
