//#define	STRICT
#include	<windows.h>
#include	<windowsx.h>
#include	<commctrl.h>
#include	<tchar.h>
#include	"resource.h"
//#include	"kctrl.h"
#include	"controls.h"
#include	"pobox.h"

extern HFONT g_hUsrFont;
int   g_iInput;
int   g_iInpmx;
POINT g_posIME = {0,0};
int   g_Curow;
int   g_Cumax;
extern InputMode	inputmode;
extern HDC g_hVDC;

extern int g_fDebug;
extern TCHAR g_bDebug[256];

extern int s_fDragDrop;
extern HWND s_hWndTerget;
extern TCHAR s_DdtClass[32];
extern HWND s_hWndGetfg;

extern BOOL		m_fNoMenu ;			/* j[\tO */
extern HWND		g_hWndMain;
extern "C" {
	extern	BOOL	g_fUpDnMode ;	//㉺L[̓
	extern	BOOL	g_inputkana;	//ȓ
	extern	BOOL	g_fIndicate;	//CWP[^
	extern	BOOL	g_fNoSendCr;	//J[\L[MȂ
	extern	int		g_PasteKey;
	extern	int 	g_EnteyWin;
} ;

int SeachEntwin (HWND hWndSend, HWND hWndTagt);
HWND GeIntoWindow ();

//Fixedɕ}
void FixedInsertString (char* mfixed, char* str)
{
	TCHAR unicode[128];
	TCHAR ufixed[128];
	TCHAR ustr[128];

	int ulen;
	int uins;

	//mfixed -> unicode ϊ
	ulen = sjis2unicode( mfixed, unicode, sizeof unicode ) ;
	if (ulen > g_Curow) ulen = g_Curow;
	//}ʒu܂łufixed
	wcsncpy (ufixed, unicode, ulen);
	ufixed[ulen] = 0;
	//str
	if (ulen > 0 && ufixed[ulen-1] == TEXT(' ') && strcmp(str," ")==0) {
		lstrcpy (&ufixed[ulen-1], TEXT("@"));
		//g_Curow += 1;
		lstrcpy (&ufixed[ulen], &unicode[ulen]);
	}
	else {
		sjis2unicode( str, ustr, sizeof ustr ) ;
		uins = lstrlen (ustr);
		lstrcpy (&ufixed[ulen], ustr);
		//}̈ʒuֈړ
		g_Curow += uins;
		//g_Cumax += uins;
		//}ʒuȍ~
		lstrcpy (&ufixed[ulen+uins], &unicode[ulen]);
	}
	//uni -> mbs
	unicode2sjis( ufixed, mfixed, 256 ) ;
	//̒
	g_Cumax =  MultiByteToWideChar (CP_ACP, 0, mfixed, -1, 0, 0);
}

extern DWORD	GetFontZW( void );  /* Sphbg */
extern DWORD	GetFontHW( void );  /* phbg */
/*
 * @́Fp`FbN
 * @́Fis_hankaku
 * @TvFUnicodepǂׂ
 * Fc = Unicode
 * ߂lFBOOL = TRUE:p, FALSE:Sp
 */
BOOL
is_hankaku( TCHAR c )
{
	return (c >= 0xFF60 && c <= 0xFF9F) || (c < 0x0080) ;
}


extern "C" {
	LRESULT CALLBACK	ConfirmWndProc( HWND hWnd,  UINT msg, WPARAM wParam, LPARAM lParam ) ;
} ;

class Confirm {
private:
	HWND	m_hWnd ;
	HWND	m_hWndParent ;		/* Rg[̐eEBhE */
	WORD	m_idCtrl ;			/* Rg[̎ʔԍ */
	CHAR	m_sInput[ 128 ] ;	/* ͕ */
	CHAR	m_sFixed[ 128 ] ;	/* m蕶 */
	HBRUSH	m_hBrushSel ;		/* I͈͂̃uV */
	HBRUSH	m_hBrushSub ;		/* I͈͂̃uV */

public:
	Confirm() ;
	~Confirm() ;

	inline	void	WMCreate( HWND hWnd, LPCREATESTRUCT lpcs ) ;
	inline	void	WMPaint() ;
	inline	void	WMChar( TCHAR c, LONG keydata ) ;
	inline	void	WMKeyDown( TCHAR c, LONG keydata ) ;
	inline	void	WMMouseDown( WPARAM wParam, LPARAM lParam );
	inline	void	WMMouseUp( WPARAM wParam, LPARAM lParam );

	inline	DWORD	GetWidth( LPCTSTR unicode ) ;

	inline	void	SetInput( LPCSTR sjis ) ;
	inline	void	SetFixed( LPCSTR sjis ) ;
	inline	void	SetSelColor( COLORREF color ) ;
} ;
typedef	Confirm	*PConfirm ;

Confirm::Confirm()
{
	m_sInput[0] = m_sFixed[0] = 0 ;
	g_iInput = g_iInpmx = 0;
	g_Curow  = g_Cumax  = 0;
	m_hBrushSel = CreateSolidBrush( RGB( 128, 128, 128 ) ) ;
	m_hBrushSub = CreateSolidBrush( RGB( 80, 80, 80 ) ) ;
}

Confirm::~Confirm()
{
	if ( m_hBrushSel ) {
		DeleteObject( m_hBrushSel ) ;
	}
	if ( m_hBrushSub ) {
		DeleteObject( m_hBrushSub ) ;
	}
}

void
Confirm::WMCreate( HWND hWnd, LPCREATESTRUCT lpcs )
{
	m_hWnd = hWnd ;
	m_hWndParent = lpcs->hwndParent ;
	m_idCtrl = (WORD) lpcs->hMenu ;
}

void
Confirm::WMPaint()
{
	PAINTSTRUCT	ps ;
	HDC			hDC ;
	RECT		rect ;
	HBRUSH		hOldBrush ;
	TCHAR		unicode[ 256 ] ;
	DWORD		w1, w2, w3, len ;
	SIZE        size;

	hDC = ::BeginPaint( m_hWnd, &ps ) ;

/*	{
		rect.left   = 0;
		rect.right  = rect.left + 4;
		rect.top    = 0;
		rect.bottom = rect.top + 20;
		HBRUSH hBrush;
		hBrush = CreateSolidBrush (0x800000);
		FillRect (hDC, &rect, hBrush);
		DeleteObject (hBrush);
		//̓[h
		if ( g_inputkana && inputmode == JAPANESE ) {
			BitBlt (hDC, 0,0, 4,5, g_hVDC, 20,0, SRCCOPY);
		}
		else {
			BitBlt (hDC, 0,0, 4,5, g_hVDC, 5 * (inputmode+1),0, SRCCOPY);
		}
		//㉺L[M[h
		if (hstr[0] == 0 && 
			(g_fUpDnMode || g_dwNumCand == 0) &&
			g_fNoSendCr == 0) {
			BitBlt (hDC, 0,6, 4,5, g_hVDC, 0,0, SRCCOPY);
		}
		//EL[M[h
		if (g_Curow == g_Cumax && *hstr == 0 && g_fNoSendCr == 0) {
			BitBlt (hDC, 0,12, 4,5, g_hVDC, 15,0, SRCCOPY);
		}
	}
*/
	HFONT hFontOld = 0;
	if (g_hUsrFont) hFontOld = (HFONT)SelectObject(hDC, g_hUsrFont);

	//NCAg
	GetClientRect( m_hWnd, &rect ) ;

	//ǉj[
	BitBlt (hDC, rect.right-98, 22-16, 98, 16, g_hVDC, 48, 0, SRCCOPY);

	//D&DŒ
	if (s_fDragDrop) {
		BitBlt (hDC, rect.right-14, 22-16, 14, 9, g_hVDC, 0, 7, SRCCOPY);
	}

	if ((g_PasteKey & 0x7f) != 'V') {
		BitBlt (hDC, rect.right-14, 0, 4, 4, g_hVDC, 16, 7, SRCCOPY);
	}
	if (g_EnteyWin) {
		BitBlt (hDC, rect.right-14+5, 0, 4, 4, g_hVDC, 21, 7, SRCCOPY);
	}

	//fobO\
	if (s_hWndTerget) {
		rect.left += 120;
		rect.top  += 2;
		SetTextColor (hDC, 0x00ff00);
		SetBkMode (hDC, TRANSPARENT);
		DrawText (hDC, s_DdtClass, -1, &rect, DT_NOCLIP | DT_NOPREFIX);
		//\̐ݒ߂
		SetTextColor (hDC, 0x000000);
		SetBkMode (hDC, OPAQUE);
		GetClientRect( m_hWnd, &rect ) ;
	}
	else if (g_fDebug) {
		rect.left += 120;
		rect.top  += 2;
		SetTextColor (hDC, 0xffff00);
		SetBkMode (hDC, TRANSPARENT);
		DrawText (hDC, g_bDebug, -1, &rect, DT_NOCLIP | DT_NOPREFIX);
		//\̐ݒ߂
		SetTextColor (hDC, 0x000000);
		SetBkMode (hDC, OPAQUE);
		GetClientRect( m_hWnd, &rect ) ;
	}

	sjis2unicode( (LPBYTE) m_sFixed, unicode, sizeof unicode ) ;
	len = _tcslen( unicode ) ;
	if ((int)len < g_Curow) g_Curow = len;
//	if ( !*m_sInput ) {
//		unicode[ len ++ ] = TEXT('_') ;
//		unicode[ len ] = 0 ;
//	}
	GetTextExtentPoint32 (hDC, unicode, len, &size);
	//w1 = GetWidth( unicode ) ;
	w1 = size.cx;

//	if (g_Curow != (int)len) {
//		sjis2unicode( (LPBYTE) m_sInput, &unicode[ g_Curow ], sizeof unicode - (g_Curow * sizeof *unicode) ) ;
//		GetTextExtentPoint32 (hDC, &unicode[ g_Curow ], g_iInput, &size);
//	}
//	else {
		sjis2unicode( (LPBYTE) m_sInput, &unicode[ len ], sizeof unicode - (len * sizeof *unicode) ) ;
		GetTextExtentPoint32 (hDC, &unicode[ len ], g_iInput, &size);
//	}
	//w2 = GetWidth( unicode ) - w1 ;
	w2 = size.cx - w1;

	rect.top += 1 ;		rect.left += 1;
//	rect.top += 1 ;		rect.left += 1 + (g_fIndicate * 4);
	rect.bottom -= 1 ;	rect.right -= 1 ;
	//KDrawText( hDC, unicode, -1, &rect, 0 ) ;
	DrawText( hDC, unicode, -1, &rect, DT_NOCLIP | DT_NOPREFIX ) ;

	//if ( !*m_sInput ) 
	{
		SIZE curs;
		GetTextExtentPoint32 (hDC, unicode, g_Curow, &curs);
		RECT rctcl;
		rctcl.left   = rect.left  + curs.cx;
		rctcl.right  = rctcl.left + 8;
		rctcl.top    = rect.top;
		rctcl.bottom = rect.bottom;
		SetBkMode (hDC, TRANSPARENT);
		rctcl.top++;
		DrawText( hDC, TEXT("_"), 1, &rctcl, DT_NOCLIP | DT_NOPREFIX ) ;
		rctcl.top++;
		DrawText( hDC, TEXT("_"), 1, &rctcl, DT_NOCLIP | DT_NOPREFIX ) ;

	if (g_fIndicate) {	//CWP[^̔wih
		RECT rctt;
	//	GetClientRect (m_hWnd, &rect);
		rctt.top    = 17;
		rctt.bottom = rctt.top + 6;
		rctt.left   = rctcl.left;
		rctt.right  = rctt.left + 7 * 3 + 4;
		HBRUSH hBrush;
		hBrush = CreateSolidBrush (0x404040);
		FillRect (hDC, &rctt, hBrush);
		DeleteObject (hBrush);
		//̓[h
		if ( g_inputkana && inputmode == JAPANESE ) {
			BitBlt (hDC, rctt.left + 2, rctt.top, 6,6, g_hVDC, 6 * 4, 0, SRCCOPY);
		}
		else {
			HIMC hImc = ImmGetContext (m_hWnd);
			int fIme = FALSE;
			if (hImc) fIme = ImmGetOpenStatus (hImc);
			if (fIme) {
				BitBlt (hDC, rctt.left + 2, rctt.top, 6,6, g_hVDC, 6 * 5, 0, SRCCOPY);
			}
			else {
				BitBlt (hDC, rctt.left + 2, rctt.top, 6,6, g_hVDC, 6 * (inputmode+1), 0, SRCCOPY);
			}
		}
		//㉺L[M[h
		if (hstr[0] == 0 && 
			(g_fUpDnMode || g_dwNumCand == 0) &&
			g_fNoSendCr == 0) {
			BitBlt (hDC, rctt.left + 2 + 7, rctt.top, 6,6, g_hVDC, 0,0, SRCCOPY);
		}
		//EL[M[h
		if (g_Curow == g_Cumax && *hstr == 0 && g_fNoSendCr == 0) {
			BitBlt (hDC, rctt.left + 2 + 7 * 2, rctt.top, 6,6, g_hVDC, 6 * 3, 0, SRCCOPY);
		}
	}
	}

	w3 = rect.right - rect.left + 1 ;
	if ( w3 > w1 ) {
		w3 -= w1 ;
		if ( w3 > w2 ) {
			w3 = w2 ;
		}
		if (inputmode == 0) {
			hOldBrush = (HBRUSH) SelectObject( hDC, m_hBrushSel ) ;
		}
		else {
			hOldBrush = (HBRUSH) SelectObject( hDC, m_hBrushSub ) ;
		}
		//PatBlt( hDC, rect.left + w1, rect.top, w3, rect.bottom - rect.top + 1, PATINVERT ) ;
		PatBlt( hDC, rect.left + w1, rect.top, size.cx, size.cy, PATINVERT ) ;
		SelectObject( hDC, hOldBrush ) ;
		if (inputmode != 0) {
			SetBkMode (hDC, TRANSPARENT);
			DrawText( hDC, unicode, -1, &rect, DT_NOCLIP | DT_NOPREFIX ) ;
		}
		g_posIME.x = rect.left + w1;
	}
	else {
		g_posIME.x = 0;
	}

	if (hFontOld) SelectObject(hDC, hFontOld);
	::EndPaint( m_hWnd, &ps ) ;

	if (g_posIME.x != g_posIME.y) {
		g_posIME.y = g_posIME.x;
		//IMËʒu
		HIMC hImc;
		COMPOSITIONFORM cif;
		memset (&cif, 0, sizeof(cif));
		hImc = ImmGetContext(m_hWnd);
		ImmGetCompositionWindow (hImc, &cif);
		cif.dwStyle = CFS_FORCE_POSITION;
		cif.ptCurrentPos.x = g_posIME.y;
		cif.ptCurrentPos.y = 0;
		ImmSetCompositionWindow (hImc, &cif);
		ImmReleaseContext(m_hWnd, hImc);
	}
}

void
Confirm::WMKeyDown( TCHAR c, LONG keydata )
{
	if ( m_hWndParent ) {
		SendMessage( m_hWndParent, WM_COMMAND, MAKEWPARAM( m_idCtrl, CONFIRMN_CODE ), c ) ;
	}
}

void
Confirm::WMMouseDown( WPARAM wParam, LPARAM lParam )
{
	WORD	xPos = LOWORD( lParam ) ;
	WORD	yPos = HIWORD( lParam ) ;

	RECT rect;
	GetClientRect( m_hWnd, &rect ) ;

	if (xPos >= rect.right-98) {
		extern HWND g_hWndMain;
		int no = (xPos-(rect.right-98)) / 14;
		switch (no) {
		case 6:	
			m_fNoMenu   = TRUE;
			s_fDragDrop = TRUE;
			SetCapture (m_hWnd);
			InvalidateRect (m_hWnd, NULL, TRUE);
			break;
		}
	}
}

void
Confirm::WMMouseUp( WPARAM wParam, LPARAM lParam )
{
	if (s_fDragDrop) {
		s_fDragDrop = FALSE;
		ReleaseCapture ();

		POINT pos;
		DWORD dwPos = GetMessagePos();
		pos.x = LOWORD (dwPos);
		pos.y = HIWORD (dwPos);
		s_hWndTerget = WindowFromPoint (pos);
		if (s_hWndTerget) {
			if (GetParent(m_hWnd) == GetParent(s_hWndTerget)) {
				s_hWndTerget = 0;
				g_bDebug[0] = 0;
				GeIntoWindow ();
				InvalidateRect (m_hWnd, NULL, TRUE);
			}
			else {
				SeachEntwin (s_hWndGetfg, s_hWndTerget);
				SendMessage( g_hWndMain, WM_COMMAND, IDM_DANDD, 0 ) ;
				return;
			}
		}
		if (m_fNoMenu) m_fNoMenu = FALSE;
	}

	WORD	xPos = LOWORD( lParam ) ;
	WORD	yPos = HIWORD( lParam ) ;

	RECT rect;
	GetClientRect( m_hWnd, &rect ) ;

//	if (xPos < 8 && yPos < 26) {
//		extern HWND g_hWndMain;
//		PostMessage (g_hWndMain, WM_COMMAND, IDM_KEYMENU, 0);
//		return;
//	}

	if (xPos >= rect.right-98) {
		extern HWND g_hWndMain;
		int no = (xPos-(rect.right-98)) / 14;
	//	TCHAR buf[80];
	//	wsprintf (buf, _T("%d"), no);
	//	MessageBox (m_hWnd, buf, NULL, MB_OK);
		switch (no) {
		case 0:	PostMessage (g_hWndMain, WM_COMMAND, IDM_KEYMENU, 0); break;
		case 1:	PostMessage (g_hWndMain, WM_COMMAND, IDM_ZENKATA, 0); break;
		case 2:	PostMessage (g_hWndMain, WM_COMMAND, IDM_ZENHIRA, 0); break;
		case 3:	PostMessage (g_hWndMain, WM_COMMAND, IDM_HAN    , 0); break;
		case 4:	PostMessage (g_hWndMain, WM_COMMAND, IDM_ROMA   , 0); break;
		case 5:	PostMessage (g_hWndMain, WM_COMMAND, IDM_SIP    , 0); break;
		case 6:	PostMessage (g_hWndMain, WM_COMMAND, IDM_DOWN   , 0); break;
		}
	}
}

void
Confirm::WMChar( TCHAR c, LONG keydata )
{
	if ( m_hWndParent ) {
		SendMessage( m_hWndParent, WM_COMMAND, MAKEWPARAM( m_idCtrl, CONFIRMN_CHAR ), c ) ;
	}
}

extern SIZE g_size;

DWORD
Confirm::GetWidth( LPCTSTR unicode )
{
	TCHAR	c ;
	DWORD	width, hw, zw ;

//	hw = ::GetFontHW() ;
//	zw = ::GetFontZW() ;
	hw = g_size.cx;
	zw = g_size.cx * 2;
	width = 0 ;
	while ( c = *unicode++ ) {
		width += is_hankaku( c ) ? hw : zw ;
	}
	return width ;
}

void
Confirm::SetInput( LPCSTR sjis )
{
	strcpy( m_sInput, sjis ) ;

	TCHAR unicode[128];
	sjis2unicode( m_sInput, unicode, sizeof unicode ) ;
	int ulen = lstrlen(unicode);
	if (g_iInpmx != ulen) {
		g_iInput = g_iInpmx = ulen;
	}
	InvalidateRect( m_hWnd, NULL, TRUE ) ;
}

void
Confirm::SetFixed( LPCSTR sjis )
{
	strcpy( m_sFixed, sjis ) ;
	{
		TCHAR		unicode[ 256 ] ;
		sjis2unicode( (LPBYTE) m_sFixed, unicode, sizeof unicode ) ;
		g_Cumax = _tcslen( unicode ) ;
	//	g_Cumax = g_Curow = _tcslen( unicode ) ;
	}
	InvalidateRect( m_hWnd, NULL, TRUE ) ;
}

void
Confirm::SetSelColor( COLORREF color )
{
	if ( m_hBrushSel ) {
		DeleteObject( m_hBrushSel ) ;
	}
	m_hBrushSel = CreateSolidBrush( color ) ;
}

BOOL
ConfirmRegisterClass( HINSTANCE hInst )
{
	WNDCLASS	wc ;

	wc.style         = NULL ;
	wc.lpfnWndProc   = (WNDPROC) ConfirmWndProc ;
	wc.cbClsExtra    = 0 ;
	wc.cbWndExtra    = 4 ;
	wc.hInstance     = hInst ;
	wc.hIcon         = NULL ;
	wc.hCursor       = NULL ;
	wc.hbrBackground = (HBRUSH) GetStockObject( WHITE_BRUSH ) ;
	wc.lpszMenuName  = 0 ;
	wc.lpszClassName = CTRL_CONFIRM ;
	return ::RegisterClass( &wc ) ;
}

LRESULT CALLBACK
ConfirmWndProc( HWND hWnd,  UINT msg, WPARAM wParam, LPARAM lParam )
{
	PConfirm	pWindow ;

	if ( msg == WM_CREATE ) {
		LPCREATESTRUCT	lpStruct = (LPCREATESTRUCT) lParam ;
		pWindow = new Confirm() ;
		SetWindowLong( hWnd, 0, (LONG) pWindow ) ;
		pWindow->WMCreate( hWnd, lpStruct ) ;
		return 0 ;
	}
	pWindow = (PConfirm) GetWindowLong( hWnd, 0 ) ;
	switch ( msg ) {
	case WM_DESTROY:
		delete pWindow ;
		SetWindowLong( hWnd, 0, (LONG) 0 ) ;
		break ;
	case WM_PAINT:
		pWindow->WMPaint() ;
		break ;
	case CONFIRM_SETINPUT:
		pWindow->SetInput( (LPCSTR) lParam ) ;
		break ;
	case CONFIRM_SETFIXED:
		pWindow->SetFixed( (LPCSTR) lParam ) ;
		break ;
	case CONFIRM_SETCOLSEL:
		pWindow->SetSelColor( (COLORREF) lParam ) ;
		break ;
	case WM_GETDLGCODE:
		return DLGC_WANTCHARS ;
	case WM_CHAR:
		pWindow->WMChar( (TCHAR) wParam, lParam ) ;
		break ;
	case WM_KEYDOWN:
		pWindow->WMKeyDown( (TCHAR) wParam, lParam ) ;
		break ;
	case WM_LBUTTONDOWN:
		pWindow->WMMouseDown( wParam, lParam ) ;
		break ;
	case WM_LBUTTONUP:
		pWindow->WMMouseUp( wParam, lParam ) ;
		break ;
	default:
		return DefWindowProc( hWnd, msg, wParam, lParam ) ;
	}
	return 0 ;
}
