#include	<windows.h>
#include	<windowsx.h>
#include	<commctrl.h>
#include	<tchar.h>
#include	"resource.h"
//#include	"controls.h"
#include	"appmain.h"

HINSTANCE	s_hInstance = NULL;
HICON		s_hIcon = NULL;
HWND		s_hDlgTop = NULL;
HWND		s_hWndOwner = NULL;
extern HWND g_hWndFep;

LRESULT CALLBACK TopMostDlgProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static int fActive = FALSE;
	switch (message) {
	case WM_INITDIALOG:
		{
			int sx = GetSystemMetrics (SM_CXSCREEN);
			int sy = GetSystemMetrics (SM_CYSCREEN);
			SetWindowPos (hDlg, HWND_TOPMOST, sx-35-9, sy-24, 9, 22, SWP_NOACTIVATE);
			s_hIcon = LoadIcon (s_hInstance, MAKEINTRESOURCE(IDI_ONSIP));
		}
		break;

	case WM_PAINT:
		{
			PAINTSTRUCT ps;
			HDC hDC;
			hDC = BeginPaint (hDlg, &ps);
			if (s_hIcon) {
				if (IsWindowVisible(g_hWndFep))
					DrawIcon (hDC, -9,0, s_hIcon);
				else
					DrawIcon (hDC, 0,0, s_hIcon);
			}
			EndPaint (hDlg, &ps);
		}
		return TRUE;

	case WM_ACTIVATE:
		if (LOWORD(wParam) != WA_INACTIVE) {
			fActive = TRUE;
			SetTimer (hDlg, 1, 2000, NULL);
		}
		else {
			fActive = FALSE;
		}
		break;

	case WM_TIMER:
		{
			KillTimer (hDlg, wParam);
			if (!IsWindowVisible(g_hWndFep) && fActive) {
				HWND hWndApp = GetCenterWindow();
				if (hWndApp) SetForegroundWindow (hWndApp);
			}
		}
		break;

	case WM_LBUTTONDOWN:
		{
			SendMessage( s_hWndOwner, WM_COMMAND, IDM_ACTIVATE, 0 ) ;
		}
		break;
	}
    return FALSE;
}

HWND CreateSipOnDlg (HINSTANCE hInstance, HWND hWnd)
{
	s_hInstance = hInstance;
	s_hWndOwner = hWnd;
#if _WIN32_WCE > 299
	s_hDlgTop = CreateDialog (hInstance, (LPCTSTR)IDD_DLG_SIPON, hWnd, (DLGPROC)TopMostDlgProc);
#endif
	if (s_hDlgTop) ShowWindow (s_hDlgTop, SW_SHOW);
	return s_hDlgTop;
}

void RedrawSipMark()
{
	if (s_hDlgTop) InvalidateRect (s_hDlgTop, NULL, FALSE);
}