#include	<windows.h>
#include	<windowsx.h>
#include	<commctrl.h>
#include	<commdlg.h>
#include	<tchar.h>
#include	"basewin.h"
#include	"resource.h"
#include	"dialog.h"
#include	"pobox.h"

#define sjis2unicode(sjis, unicode, len)	MultiByteToWideChar(CP_ACP, 0, (char*)sjis, -1, unicode, len)

extern TCHAR	g_bDebug[256];
extern int		g_fDebug;

extern int		MAX_DIC;
TCHAR	PHRASEFILE[32] = TEXT("phrases");
TCHAR	WORDFILE[32]   = TEXT("words");

extern "C" {
	extern int		g_fProcessKey;			//[ϊ]L[Xy[X̕ς
//	extern int		g_nExType;				//[g]\
	extern int		g_PasteKey;				//y[XgL[

	//L[}bv
	extern Key	g_KeyRoma[70];
	extern Key	g_KeyNormal[70];
	extern Key	g_KeyShift[70];
	extern Key	g_KeyHira[70];

	//L[{[hC[WBMPt@C
	extern TCHAR g_KBordBmp[5][256];

};

typedef struct {
	BYTE	key[16];
	int		id;
	char*	name;
	LPWSTR unicode;
}	KEYID;
KEYID s_keyid[] = {
    {"IDM_ALT_0"      ,IDM_ALT_0      ,"", (LPWSTR) 0},
    {"IDM_ALT_1"      ,IDM_ALT_1      ,"", (LPWSTR) 0},
    {"IDM_ALT_2"      ,IDM_ALT_2      ,"", (LPWSTR) 0},
    {"IDM_ALT_3"      ,IDM_ALT_3      ,"", (LPWSTR) 0},
    {"IDM_ALT_4"      ,IDM_ALT_4      ,"", (LPWSTR) 0},
    {"IDM_ALT_5"      ,IDM_ALT_5      ,"", (LPWSTR) 0},
    {"IDM_ALT_6"      ,IDM_ALT_6      ,"", (LPWSTR) 0},
    {"IDM_ALT_7"      ,IDM_ALT_7      ,"", (LPWSTR) 0},
    {"IDM_ALT_8"      ,IDM_ALT_8      ,"", (LPWSTR) 0},
    {"IDM_ALT_9"      ,IDM_ALT_9      ,"", (LPWSTR) 0},
    {"IDM_APL_SEL"    ,IDM_APL_SEL    ,"", (LPWSTR) 0},
    {"IDM_APL_COPY"   ,IDM_APL_COPY   ,"", (LPWSTR) 0},
    {"IDM_APL_PASTE"  ,IDM_APL_PASTE  ,"", (LPWSTR) 0},
    {"IDM_APL_REDO"   ,IDM_APL_REDO   ,"", (LPWSTR) 0},
    {"IDM_APL_UNDO"   ,IDM_APL_UNDO   ,"", (LPWSTR) 0},
    {"IDM_APL_CUT"    ,IDM_APL_CUT    ,"", (LPWSTR) 0},
    {"IDM_JMODE"      ,IDM_JMODE      ,"", (LPWSTR) 0},
    {"IDM_JIS"        ,IDM_JIS        ,"", (LPWSTR) 0},
    {"IDM_ALT_LR"     ,IDM_ALT_LR     ,"KBړ", (LPWSTR) 0},
    {"IDM_ALT_MODE"   ,IDM_ALT_MODE   ,"", (LPWSTR) 0},
    {"IDM_ADDDICT"    ,IDM_ADDDICT    ,"", (LPWSTR) 0},

	{"IDM_SKB_NONE"   ,IDM_SKB_NONE   ,"KB:Ȃ", (LPWSTR) 0},
	{"IDM_SKB_HIRA"   ,IDM_SKB_HIRA   ,"KB:Ђ", (LPWSTR) 0},
	{"IDM_SKB_ROMA"   ,IDM_SKB_ROMA   ,"KB:۰ώ", (LPWSTR) 0},
	{"IDM_SKB_LINE"   ,IDM_SKB_LINE   ,"KB:Ps", (LPWSTR) 0},
	{"IDM_SKB_EXTP"   ,IDM_SKB_EXTP   ,"KB:g", (LPWSTR) 0},
	{"IDM_SKB_10KEY"  ,IDM_SKB_10KEY  ,"KB:10L[", (LPWSTR) 0},
    {"--"             ,-1             ,"-", (LPWSTR) 0},

	{"IDM_ZENKATA"    ,IDM_ZENKATA    ,"", (LPWSTR) 0},	//":SJi"},
    {"IDM_HAN"        ,IDM_HAN        ,"", (LPWSTR) 0},	//":@p"},
    {"IDM_ROMA"       ,IDM_ROMA       ,"", (LPWSTR) 0},	//":۰ώ"},
    {"IDM_ZENHIRA"    ,IDM_ZENHIRA    ,"", (LPWSTR) 0},	//":SЂ"},

    {"IDM_20KEY"      ,IDM_20KEY      ,"20KEY[h", (LPWSTR) 0},
    {"IDM_10KEY"      ,IDM_10KEY      ,"10KEY[h", (LPWSTR) 0},
    {"IDM_JPNENG"     ,IDM_JPNENG     ,"p؂ւ", (LPWSTR) 0},
    {"IDM_CLIP"       ,IDM_CLIP       ,"دްޗ", (LPWSTR) 0},
    {"IDM_ADDDICTDLG" ,IDM_ADDDICTDLG ,"o^", (LPWSTR) 0},
    {"IDM_WNDENT"     ,IDM_WNDENT     ,"޳o^", (LPWSTR) 0},
    {"IDM_SETUP"      ,IDM_SETUP      ,"ZbgAbv", (LPWSTR) 0},
    {"IDM_EXIT"       ,IDM_EXIT       ,"PQBoxI", (LPWSTR) 0},

    {"IDM_NEXT"       ,IDM_NEXT       ,"", (LPWSTR) 0},
    {"IDM_PREV"       ,IDM_PREV       ,"", (LPWSTR) 0},
    {"IDM_BACKSPACE"  ,IDM_BACKSPACE  ,"", (LPWSTR) 0},
    {"IDM_DELETE"     ,IDM_DELETE     ,"", (LPWSTR) 0},
    {"IDM_ESCAPE"     ,IDM_ESCAPE     ,"", (LPWSTR) 0},
    {"IDM_ENTER"      ,IDM_ENTER      ,"", (LPWSTR) 0},
    {"IDM_UP"         ,IDM_UP         ,"", (LPWSTR) 0},
    {"IDM_DOWN"       ,IDM_DOWN       ,"", (LPWSTR) 0},
    {"IDM_LEFT"       ,IDM_LEFT       ,"", (LPWSTR) 0},
    {"IDM_RIGHT"      ,IDM_RIGHT      ,"", (LPWSTR) 0},
    {"IDM_SHIFT_DN2"  ,IDM_SHIFT_DN2  ,"", (LPWSTR) 0},
    {"IDM_SHIFT_LF"   ,IDM_SHIFT_LF   ,"", (LPWSTR) 0},
    {"IDM_SHIFT_LF2"  ,IDM_SHIFT_LF2  ,"", (LPWSTR) 0},
    {"IDM_SHIFT_UP2"  ,IDM_SHIFT_UP2  ,"", (LPWSTR) 0},
    {"IDM_SHIFT_RT"   ,IDM_SHIFT_RT   ,"", (LPWSTR) 0},
    {"IDM_SHIFT_RT2"  ,IDM_SHIFT_RT2  ,"", (LPWSTR) 0},
    {"IDM_SHIFT_EN"   ,IDM_SHIFT_EN   ,"", (LPWSTR) 0},
    {"IDM_TAB"        ,IDM_TAB        ,"", (LPWSTR) 0},
    {"IDM_UNDO"       ,IDM_UNDO       ,"", (LPWSTR) 0},

    {"IDC_CHK_SAVE"   ,IDC_CHK_SAVE   ,"", (LPWSTR) 0},
    {"IDC_PREDICT"    ,IDC_PREDICT    ,"", (LPWSTR) 0},
    {"IDC_CQUICK"     ,IDC_CQUICK     ,"", (LPWSTR) 0},

    {"IDM_HIDE"       ,IDM_HIDE       ,"", (LPWSTR) 0},
    {"IDM_SIP"        ,IDM_SIP        ,"", (LPWSTR) 0},

    {"DEBUG"          ,IDM_FLAG_DEBUG ,"", (LPWSTR) 0},
    {"PROCESSKEY"     ,IDM_FLAG_PKEY  ,"", (LPWSTR) 0},
    {"MAXDIC"         ,IDM_FLAG_MAXDIC,"", (LPWSTR) 0},
    {"PASTEKEY"       ,IDM_FLAG_PASTE ,"", (LPWSTR) 0},
//	{"EXTYPE"         ,IDM_FLAG_EXTYPE,"", (LPWSTR) 0},

	{"", 0},
};

OSVERSIONINFO oi;
int ver = 211;

#define MAX_ACCEL	50

//#pragma pack (2)
/*
typedef struct tagACCELX {
BYTE fVirt;
WORD key;
WORD cmd;
//WORD pad;
} ACCELX;
//#define ACCELX ACCEL
*/
int		s_nAcel = 0;
//ACCELX	s_AcelX[MAX_ACCEL];
ACCEL	s_Acel0[MAX_ACCEL];
/*
ACCELX s_Accel[] = {
	{FVIRTKEY| FNOINVERT| FALT    ,  'Q',            IDM_CLIP        },
    {FVIRTKEY| FNOINVERT| FALT    ,  'H',            IDM_EXIT        },
	{FVIRTKEY| FNOINVERT| FCONTROL,  '0',            IDM_ALT_0       },
	{FVIRTKEY| FNOINVERT| FCONTROL,  '1',            IDM_ALT_1       },
	{FVIRTKEY| FNOINVERT| FCONTROL,  '2',            IDM_ALT_2       },
	{FVIRTKEY| FNOINVERT| FCONTROL,  '3',            IDM_ALT_3       },
    {FVIRTKEY| FNOINVERT| FCONTROL,  '4',            IDM_ALT_4       },
    {FVIRTKEY| FNOINVERT| FCONTROL,  '5',            IDM_ALT_5       },
    {FVIRTKEY| FNOINVERT| FCONTROL,  '6',            IDM_ALT_6       },
    {FVIRTKEY| FNOINVERT| FCONTROL,  '7',            IDM_ALT_7       },
    {FVIRTKEY| FNOINVERT| FCONTROL,  '8',            IDM_ALT_8       },
    {FVIRTKEY| FNOINVERT| FCONTROL,  '9',            IDM_ALT_9       },
//	{FVIRTKEY| FNOINVERT| FCONTROL,  'A',            IDM_APL_SEL     },
//	{FVIRTKEY| FNOINVERT| FALT    ,  'A',            IDM_ADDDICT     },
    {FVIRTKEY| FNOINVERT| FALT    ,  'B',            IDM_PREV        },
//	{FVIRTKEY| FNOINVERT| FCONTROL,  'C',            IDM_APL_COPY    },
    {FVIRTKEY| FNOINVERT| FALT    ,  'D',            IDM_ADDDICTDLG  },
    {FVIRTKEY| FNOINVERT| FALT    ,  'I',            IDM_ZENKATA     },
    {FVIRTKEY| FNOINVERT| FALT    ,  'J',            IDM_JIS         },
    {FVIRTKEY| FNOINVERT| FALT    ,  'L',            IDM_ALT_LR      },
    {FVIRTKEY| FNOINVERT| FALT    ,  'M',            IDM_ALT_MODE    },
    {FVIRTKEY| FNOINVERT| FALT    ,  'N',            IDM_NEXT        },
    {FVIRTKEY| FNOINVERT| FALT    ,  'O',            IDM_HAN         },
    {FVIRTKEY| FNOINVERT| FALT    ,  'P',            IDM_ROMA        },
    {FVIRTKEY| FNOINVERT| FALT    ,  'S',            IDM_SETUP       },
    {FVIRTKEY| FNOINVERT| FALT    ,  'U',            IDM_ZENHIRA     },
//	{FVIRTKEY| FNOINVERT| FCONTROL,  'V',            IDM_APL_PASTE   },
	{FVIRTKEY| FNOINVERT          ,  VK_BACK,        IDM_BACKSPACE   },
    {FVIRTKEY| FNOINVERT          ,  VK_DELETE,      IDM_DELETE      },
	{FVIRTKEY| FNOINVERT          ,  VK_DOWN,        IDM_DOWN        },
	{FVIRTKEY| FNOINVERT| FSHIFT  ,  VK_DOWN,        IDM_SHIFT_DN2   },
	{FVIRTKEY| FNOINVERT          ,  VK_ESCAPE,      IDM_ESCAPE      },
//	{FVIRTKEY| FNOINVERT          ,  VK_LEFT,        IDM_LEFT        },
	{FVIRTKEY| FNOINVERT          ,  VK_LEFT,        IDM_BACKSPACE   },
    {FVIRTKEY| FNOINVERT| FCONTROL,  VK_LEFT,        IDM_SHIFT_LF    },
    {FVIRTKEY| FNOINVERT| FSHIFT  ,  VK_LEFT,        IDM_SHIFT_LF2   },
    {FVIRTKEY| FNOINVERT          ,  VK_NEXT,        IDM_NEXT        },
    {FVIRTKEY| FNOINVERT          ,  VK_PRIOR,       IDM_PREV        },
	{FVIRTKEY| FNOINVERT          ,  VK_RETURN,      IDM_ENTER       },
    {FVIRTKEY| FNOINVERT| FSHIFT  ,  VK_RETURN,      IDM_SHIFT_EN    },
    {FVIRTKEY| FNOINVERT          ,  VK_RIGHT,       IDM_RIGHT       },
    {FVIRTKEY| FNOINVERT| FCONTROL,  VK_RIGHT,       IDM_SHIFT_RT    },
    {FVIRTKEY| FNOINVERT| FSHIFT  ,  VK_RIGHT,       IDM_SHIFT_RT2   },
    {FVIRTKEY| FNOINVERT          ,  VK_TAB,         IDM_TAB         },
    {FVIRTKEY| FNOINVERT| FSHIFT  ,  VK_TAB,         IDM_JPNENG      },
    {FVIRTKEY| FNOINVERT          ,  VK_UP,          IDM_UP          },
    {FVIRTKEY| FNOINVERT| FSHIFT  ,  VK_UP,          IDM_SHIFT_UP2   },
	{FVIRTKEY| FNOINVERT| FALT    ,  'W',            IDM_CLIP        },
//	{FVIRTKEY| FNOINVERT| FCONTROL,  'X',            IDM_APL_CUT     },
    {FVIRTKEY| FNOINVERT| FALT    ,  'X',            IDM_EXIT        },
//	{FVIRTKEY| FNOINVERT| FCONTROL,  'Y',            IDM_APL_REDO    },
//	{FVIRTKEY| FNOINVERT| FCONTROL,  'Z',            IDM_APL_UNDO    },
    {FVIRTKEY| FNOINVERT| FALT    ,  'Z',            IDM_JMODE       },
};
*/
//-------------------------------------
int KeyID_Menu (HWND hWnd, HWND hWndClient)
{
	extern POINT g_posIME;
	extern int key20_mode, key10_mode;

	HMENU hMenu = CreatePopupMenu() ;
	if (hMenu == 0) return 0;
 
	POINT Pos;
	Pos.x = g_posIME.y;
	Pos.y = 0;
	ClientToScreen (hWndClient, &Pos);
	
	UINT flag;
	int i;
	for (i = 0; s_keyid[i].key[0] != 0; i++) {
		if (s_keyid[i].name[0]) {
			if (s_keyid[i].name[0] == '-')
				::AppendMenu (hMenu, MF_SEPARATOR, 0,0);
			else {
			  if (!s_keyid[i].unicode) {
			    s_keyid[i].unicode = new WCHAR[256];
				MultiByteToWideChar(CP_ACP, 0, s_keyid[i].name, -1, s_keyid[i].unicode, 256);
			  }
				if (s_keyid[i].id == IDM_20KEY) {
				  flag = MF_STRING | (key20_mode?MF_CHECKED:MF_UNCHECKED);
				} else if (s_keyid[i].id == IDM_10KEY) {
				  flag = MF_STRING | (key10_mode?MF_CHECKED:MF_UNCHECKED);

				} else {
				  flag = MF_STRING;
				}
				::AppendMenu (hMenu, flag, s_keyid[i].id , s_keyid[i].unicode);
			}
		}
	}

	int id = ::TrackPopupMenu (hMenu, 
		TPM_BOTTOMALIGN|TPM_LEFTALIGN |TPM_NONOTIFY|TPM_RETURNCMD,
		Pos.x, Pos.y, 0, hWnd, NULL);

	::DestroyMenu (hMenu);

	if (id) {
		PostMessage (hWnd, WM_COMMAND, id, 0);
	}

	return 0;
}

//-------------------------------------
int KeyID_Entry (ACCEL* accel)
{
	if (s_nAcel >= MAX_ACCEL) return FALSE;

//	if (ver > 209) {
		memcpy (&s_Acel0[s_nAcel], accel, sizeof(ACCEL));
//	}
//	else {
//		memcpy (&s_AcelX[s_nAcel], accel, sizeof(ACCELX));
//	}
	s_nAcel++;
	return TRUE;
/*
	int i;
	int max = sizeof(s_Accel) / sizeof(ACCELX);

	for (i = 0; max; i++) {
		if (s_Accel[i].cmd == accel->cmd) {
			memcpy (&s_Accel[i], accel, sizeof(ACCELX));
			return 1;
		}
	}
	return 0;
*/
}

//-------------------------------------
int KeyID_Seach (BYTE* key)
{
	int i;
	for (i = 0; s_keyid[i].key[0] != 0; i++) {
		if (strcmp((char*)key, (char*)s_keyid[i].key) == 0)
			return s_keyid[i].id;
	}
	return 0;
}

//-------------------------------------
// bufJbgavXgɍڂ
int Param_Branch (BYTE* buf, BYTE* av[])
{
	int i = 0;
	int k;
	int ac = 0;
	int len = strlen ((char*)buf);
	BYTE p[256];

	// skip space
	for (; i < len && buf[i] <= TEXT(' '); i++);

	for (i = 0; i < len;) {
		if (buf[i] == '#') break;
		k = 0;
		// ̋؂܂ňړ
		if (buf[i] == TEXT('\"')) {
			i++;
			for (; i < len && buf[i] != TEXT('\"') ; i++) {
				if (buf[i] == TEXT('\\')) {
					if (buf[i+1] == TEXT('\\') || 
						buf[i+1] == TEXT('\"'))
						i++;
				}
				p[k] = buf[i];
				k++;
				p[k] = 0;
			}
			if (k == 0) {
					p[k] = 0;
					k++;
					p[k] = 0;
			}
			for (; i < len && 
				buf[i] != TEXT('#') && 
				buf[i] != TEXT(' ') && 
				buf[i] != TEXT('\t') && 
				buf[i] != TEXT(',') && 
				buf[i] != TEXT('=') &&
				buf[i] != TEXT('<') &&
				buf[i] != TEXT('>') ; i++) {
			}
		}
		else {
			for (; i < len && 
				buf[i] != TEXT('#') && 
				buf[i] != TEXT(' ') && 
				buf[i] != TEXT('\t') && 
				buf[i] != TEXT(',') && 
				buf[i] != TEXT('=') &&
				buf[i] != TEXT('<') &&
				buf[i] != TEXT('>') ; i++) {
					p[k] = buf[i];
					k++;
					p[k] = 0;
			}
		}
		if (k == 0) {
			if (i < len) i++;
		}
		p[k] = 0;
		if (k) {
			k++;
			av[ac] = (BYTE*) LocalAlloc (LPTR, k);
			memcpy (av[ac], p, k);
			ac++;
			if (ac >= 16-1) break;
		}
		// skip space
		for (; i < len && buf[i] <= TEXT(' '); i++);
	}
	return ac;
}
//-------------------------------------
BYTE* Param_WCuat (BYTE* str)
{
	char* s;
	char* e;
	s = strchr ((char*)str, '\"');
	if (s) {
		s++;
		if (*s == '\\') {
			if (*(s+1) >= '!' && *(s+1) <= '@')
				s++;
		}
		e = strchr ((char*)s, '\"');
		if (e) *e = 0;
	}
	else {
		s = (char*)str;
		if (*s == '\\') {
			if (*(s+1) != 0)
				s++;
		}
	}
	return (BYTE*)s;
}
//-------------------------------------
void Param_Free (int ac, BYTE* av[])
{
	int i;
	for (i = 0; i < ac; i++) {
		if (av[i]) LocalFree ((char*)av[i]);
	}
}

//-------------------------------------
static void fGetOne (BYTE* p, DWORD* pdwPoint, BYTE* pBuf, DWORD dwSize)
{
	if (dwSize > *pdwPoint) {
		*p = pBuf[*pdwPoint];
		(*pdwPoint)++;
	}
	else {
		*p = 0;
	}
}

//-------------------------------------
int fGetLine (BYTE* mbs, int size, DWORD* pdwPoint, BYTE* pBuf, DWORD dwSize)
{
	int len = 0;
	while (len < size) {
		fGetOne (&mbs[len], pdwPoint, pBuf, dwSize);
		if (*pdwPoint >= dwSize) break;
		len++;
		if (mbs[len-1] == TEXT('\n')) break;
	}
	mbs[len] = 0;
	len++;	
	return len;
}

//-------------------------------------
HACCEL LoadKeyfile (HINSTANCE hInstance)
{
//	{
//	int max = sizeof(s_Accel) / sizeof(ACCELX);
//	HACCEL hAccel = CreateAcceleratorTable ((LPACCEL)s_Accel, max/2);
//	return hAccel;
//	}
	memset (&oi, 0, sizeof(OSVERSIONINFO));
	oi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx (&oi);
	ver = oi.dwMajorVersion * 100 + oi.dwMinorVersion;
//	ver = 200;

	TCHAR buf[MAX_PATH];
	GetModuleFileName (hInstance, buf, MAX_PATH);
	{
		TCHAR* p = wcsrchr (buf, TEXT('\\'));
		if (p != 0) *(p+1) = 0;
	}

	//ݒt@C
	TCHAR cFileName[MAX_PATH];
	wsprintf (cFileName, TEXT("%sPQBox.key"), buf);

	//t@CJ
	HANDLE hFile;
	hFile = CreateFile (cFileName, GENERIC_READ,
		FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING,
		0, (HANDLE)NULL);
	if (hFile == (HANDLE)INVALID_HANDLE_VALUE)
		return NULL;

	//t@CTCY
	DWORD dwFileSize = GetFileSize (hFile, NULL);

	//[hobt@쐬
	BYTE* szData = (BYTE*)LocalAlloc (LPTR, dwFileSize+256);
	if (szData == 0) {
		CloseHandle(hFile);
		return NULL;
	}

	//f[^ǂݍ
	DWORD dwSize;
	ReadFile (hFile, szData, dwFileSize, &dwSize, NULL);

	//t@C
	CloseHandle (hFile);

	int i;
	int rc;
	DWORD dwPoint = 0;
	BYTE  mbs[100];
	int ac;
	BYTE* av[16+1];
	int id;
	ACCEL accel;

	for (i = 0; i < 256; i++) {
		rc = fGetLine (mbs, 100-1, &dwPoint, szData, dwFileSize);
		if (rc > 0 && mbs[0] != '#') {
			ac = Param_Branch (mbs, av);
			if (ac >= 2) {
				id = KeyID_Seach (av[0]);
				if (id) {
					memset (&accel, 0, sizeof(accel));
					accel.fVirt = FVIRTKEY | FNOINVERT;
					accel.cmd   = id;
					BYTE* p = av[1];
					for (int j = 0; p[j] != 0; j++) {
						if (p[j] == '%') accel.fVirt |= FALT;
						if (p[j] == '^') accel.fVirt |= FCONTROL;
						if (p[j] == '+') accel.fVirt |= FSHIFT;
						if (p[j] >= 'A' && p[j] <= 'Z') {
							accel.key = p[j];
							break;
						}
						if (p[j] >= '0' && p[j] <= '9') {
							int n;
							TCHAR unicode[80];
							if (memcmp (&p[j], "0x", 2) == 0) {
								sjis2unicode (&p[j+2], unicode, sizeof unicode ) ;
								swscanf (unicode, TEXT("%x"), &n);
							}
							else {
								sjis2unicode (&p[j], unicode, sizeof unicode ) ;
								swscanf (unicode, TEXT("%d"), &n);
								n += '0';
							}
							accel.key = n;
							break;
						}
					}
					switch (id) {
					case IDM_FLAG_DEBUG  :
						g_fDebug = accel.key & 0x0f;
						break;
					case IDM_FLAG_PKEY   :
						g_fProcessKey = accel.key;
						break;
					case IDM_FLAG_MAXDIC :
						if (accel.key == 16) {
							MAX_DIC = 16;
							lstrcpy (PHRASEFILE, TEXT("phrase"));
							lstrcpy (WORDFILE  , TEXT("word"));
						}
						break;
					case IDM_FLAG_PASTE:
						g_PasteKey = accel.key;
						if (accel.fVirt & FALT    ) g_PasteKey |= MAKELONG(0,MOD_ALT);
						if (accel.fVirt & FCONTROL) g_PasteKey |= MAKELONG(0,MOD_CONTROL);
						if (accel.fVirt & FSHIFT  ) g_PasteKey |= MAKELONG(0,MOD_SHIFT);
						break;
					//case IDM_FLAG_EXTYPE :
					//	g_nExType = accel.key;
					//	break;
					default:
						if (accel.cmd) KeyID_Entry (&accel);
						break;
					}
				}
			}
			Param_Free (ac, av);
		}
		if (dwPoint >= dwFileSize) break;
	}

	//J
	LocalFree ((HANDLE)szData);

	if (s_nAcel == 0) return NULL;

//	int max = sizeof(s_Accel) / sizeof(ACCELX);
	HACCEL hAccel = 0;
	if (ver > 209) {
		hAccel = CreateAcceleratorTable ((LPACCEL)s_Acel0, s_nAcel);
	}
//	else {
//		hAccel = CreateAcceleratorTable ((LPACCEL)s_AcelX, s_nAcel);
//	}

	return hAccel;
}
//-------------------------------------
int TranslateAccelEx (HWND hWnd, MSG* msg)
{
	if (ver > 209)
		return FALSE;
	if (s_nAcel == 0)
		return FALSE;
	if (msg->message != WM_KEYDOWN && 
		msg->message != WM_SYSKEYDOWN)
		return FALSE;

	int fAlt   = (GetAsyncKeyState (VK_MENU)    & 0x8000) ? FALT : 0;
	int fShift = (GetAsyncKeyState (VK_SHIFT)   & 0x8000) ? FSHIFT : 0;
	int fCtrl  = (GetAsyncKeyState (VK_CONTROL) & 0x8000) ? FCONTROL : 0;
	int fKey   = LOWORD(msg->wParam);
	if (fKey >= 'a' && fKey <= 'z') fKey -= 0x20;

	if (fKey == VK_SHIFT   ||
		fKey == VK_CONTROL ||
		fKey == VK_MENU)
		return FALSE;

	for (int i = 0; i < s_nAcel; i++) {
		if (s_Acel0[i].key == fKey) {
			if ((s_Acel0[i].fVirt & FALT    ) == fAlt   &&
				(s_Acel0[i].fVirt & FSHIFT  ) == fShift &&
				(s_Acel0[i].fVirt & FCONTROL) == fCtrl  ) {
				msg->hwnd    = hWnd;
				msg->message = WM_COMMAND;
				msg->wParam  = s_Acel0[i].cmd;
				msg->lParam  = 0;
				//wsprintf (g_bDebug, TEXT("Key=%c"), fKey);
				return TRUE;
			}
		}
	}
	return FALSE;
}
//-------------------------------------
// L[{[h}bp[e[uǂݍ
int LoadTblfile (HINSTANCE hInstance)
{
	TCHAR buf[MAX_PATH];
	GetModuleFileName (hInstance, buf, MAX_PATH);
	{
		TCHAR* p = wcsrchr (buf, TEXT('\\'));
		if (p != 0) *(p+1) = 0;
	}

	//ݒt@C
	TCHAR cFileName[MAX_PATH];
	wsprintf (cFileName, TEXT("%sPQBox.tbl"), buf);

	//t@CJ
	HANDLE hFile;
	hFile = CreateFile (cFileName, GENERIC_READ,
		FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING,
		0, (HANDLE)NULL);
	if (hFile == (HANDLE)INVALID_HANDLE_VALUE)
		return FALSE;

	//t@CTCY
	DWORD dwFileSize = GetFileSize (hFile, NULL);

	//[hobt@쐬
	BYTE* szData = (BYTE*)LocalAlloc (LPTR, dwFileSize+256);
	if (szData == 0) {
		CloseHandle(hFile);
		return FALSE;
	}

	//f[^ǂݍ
	DWORD dwSize;
	ReadFile (hFile, szData, dwFileSize, &dwSize, NULL);

	//t@C
	CloseHandle (hFile);

	int i;
	int rc;
	DWORD dwPoint = 0;
	BYTE  mbs[256];
	int ac;
	BYTE* av[16+1];
	int  kcnt = 0;
	Key* key  = 0;

	for (i = 0; i < 512; i++) {
		rc = fGetLine (mbs, 256-1, &dwPoint, szData, dwFileSize);
		if (rc > 0 && mbs[0] == '[') {
			kcnt = 0;
			if (memcmp(mbs,"[ROMA]"    , 6) == 0) key	= g_KeyRoma;
			else if (memcmp(mbs,"[ENG]"     , 5) == 0) key	= g_KeyNormal;
			else if (memcmp(mbs,"[ENGSHIFT]",10) == 0) key	= g_KeyShift;
			else if (memcmp(mbs,"[HIRA]"    , 6) == 0) key	= g_KeyHira;
			else key = 0;
			if (key != 0) memset (key, 0, sizeof(Key) * 64);
		}
		if (key == 0 || rc <= 0 || mbs[0] == '#') {
			if (dwPoint >= dwFileSize) break;
			continue;
		}
		ac = Param_Branch (mbs, av);
		if (ac >= 2 && *av[0] == 'B') {
			BYTE* str = Param_WCuat (av[1]);
			if (key == g_KeyRoma  ) sjis2unicode (str, g_KBordBmp[0], sizeof g_KBordBmp[0]);
			if (key == g_KeyNormal) sjis2unicode (str, g_KBordBmp[1], sizeof g_KBordBmp[0]);
			if (key == g_KeyShift ) sjis2unicode (str, g_KBordBmp[2], sizeof g_KBordBmp[0]);
			if (key == g_KeyHira  ) sjis2unicode (str, g_KBordBmp[3], sizeof g_KBordBmp[0]);
			if (key == g_Key10  ) sjis2unicode (str, g_KBordBmp[4], sizeof g_KBordBmp[0]);
		}
		if (ac >= 7 && *av[0] == 'K') {
			int j;
			int n[4];
			for (j = 0; j < 4; j++) {
				TCHAR unicode[80];
				sjis2unicode (av[j+1], unicode, sizeof unicode);
				n[j] = _wtoi (unicode);
			}
			if (kcnt < 68) {
			//	BYTE* str  = Param_WCuat (av[5]);
			//	BYTE* yomi = Param_WCuat (av[6]);
				key[kcnt].x      = n[0];
				key[kcnt].y      = n[1];
				key[kcnt].width  = n[2];
				key[kcnt].height = n[3];
				strncpy (key[kcnt].str , (char*)av[5], 63);
				strncpy (key[kcnt].yomi, (char*)av[6], 63);
				kcnt ++;
			}
		}
		Param_Free (ac, av);
		if (dwPoint >= dwFileSize) break;
	}

	//J
	LocalFree ((HANDLE)szData);

	return TRUE;
}

extern int g_fStretchSize;

void KeyStretchSize (Key* key)
{
	int i;
	for (i = 0; i < 70; i++) {
		if (key[i].str[0] == 0) break;
		key[i].x      *= g_fStretchSize;
		key[i].y      *= g_fStretchSize;
		key[i].width  *= g_fStretchSize;
		key[i].height *= g_fStretchSize;
	}
}

void KeyStretchSizeAll ()
{
	if (g_fStretchSize < 2) return;
	KeyStretchSize (g_KeyRoma);
	KeyStretchSize (g_KeyNormal);
	KeyStretchSize (g_KeyShift);
	KeyStretchSize (g_KeyHira);
}

//-------------------------------------
//-------------------------------------
/*
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
,0
*/
